# -*- coding: utf-8 -*-
# @Time    : 2024/6/7
# @Author  : 魏志亮

from service.common_connect import plt


def get_all_wind(field_code, need_rated_param=True):
    query_sql = """
    SELECT t.engine_code,t.engine_name,t.rated_capacity,a.rated_cut_out_windspeed 
    from wind_engine_group t LEFT JOIN wind_engine_mill a on t.mill_type_code  = a.mill_type_code 
    where t.field_code = %s and t.del_state = 0
    """
    dict_datas = plt.execute(query_sql, (field_code,))
    wind_result = dict()
    power_result = dict()
    for data in dict_datas:
        wind_result[str(data['engine_name'])] = str(data['engine_code'])
        if need_rated_param:
            power_result[str(data['engine_code'])] = (
                float(data['rated_capacity']), float(data['rated_cut_out_windspeed']))
    return wind_result, power_result


def get_all_wind_company():
    query_sql = "SELECT t.field_name FROM wind_field t where t.del_state = 0"
    datas = plt.execute(query_sql)
    if datas:
        return [v for data in datas for k, v in data.items()]
    else:
        return ['吉山风电场', '和风元宝山', '唐龙三期风电场', '密马风电场', '招远风电场', '昌平坳风场', '昌西一风电场',
                '虹梯官风电场', '长清风电场']


def get_base_wind_and_power(wind_turbine_number):
    query_sql = "SELECT rated_wind_speed,rated_capacity FROM wind_engine_group where engine_code = %s order by rated_wind_speed"
    dict_datas = plt.execute(query_sql, (wind_turbine_number,))
    if type(dict_datas) == tuple:
        return None
    return dict_datas

